Hex Artifact Content

Artifact bf636f72b1b0d2b618d131f521506a222f14c1fa:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 66 32 34 33 35 33 64 30  bash..# f24353d0
0020: 32 64 39 30 66 39 37 63 37 32 62 36 39 37 37 66  2d90f97c72b6977f
0030: 33 61 38 61 30 35 30 30 36 61 64 30 36 31 32 30  3a8a05006ad06120
0040: 0a 0a 6f 75 72 53 63 72 69 70 74 3d 22 24 28 77  ..ourScript="$(w
0050: 68 69 63 68 20 22 24 30 22 29 22 0a 69 66 20 21  hich "$0")".if !
0060: 20 68 65 61 64 20 2d 33 20 22 24 7b 6f 75 72 53   head -3 "${ourS
0070: 63 72 69 70 74 7d 22 20 32 3e 2f 64 65 76 2f 6e  cript}" 2>/dev/n
0080: 75 6c 6c 20 7c 20 67 72 65 70 20 66 32 34 33 35  ull | grep f2435
0090: 33 64 30 32 64 39 30 66 39 37 63 37 32 62 36 39  3d02d90f97c72b69
00a0: 37 37 66 33 61 38 61 30 35 30 30 36 61 64 30 36  77f3a8a05006ad06
00b0: 31 32 30 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  120 >/dev/null; 
00c0: 74 68 65 6e 0a 09 65 63 68 6f 20 22 65 72 72 6f  then..echo "erro
00d0: 72 3a 20 55 6e 61 62 6c 65 20 74 6f 20 66 69 6e  r: Unable to fin
00e0: 64 20 6f 75 72 73 65 6c 76 65 73 22 20 3e 26 32  d ourselves" >&2
00f0: 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 63 64  ...exit 1.fi..cd
0100: 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24 7b 6f   "$(dirname "${o
0110: 75 72 53 63 72 69 70 74 7d 22 29 22 20 7c 7c 20  urScript}")" || 
0120: 65 78 69 74 20 31 0a 0a 70 61 74 63 68 44 69 72  exit 1..patchDir
0130: 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65 73  ="$(pwd)/patches
0140: 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 4e 41  "..if [ -z "${NA
0150: 43 4c 5f 53 44 4b 5f 52 4f 4f 54 7d 22 20 5d 3b  CL_SDK_ROOT}" ];
0160: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 65 72 72   then..echo "err
0170: 6f 72 3a 20 50 6c 65 61 73 65 20 73 65 74 20 4e  or: Please set N
0180: 41 43 4c 5f 53 44 4b 5f 52 4f 4f 54 20 74 6f 20  ACL_SDK_ROOT to 
0190: 74 68 65 20 70 61 74 68 20 6f 66 20 74 68 65 20  the path of the 
01a0: 63 75 72 72 65 6e 74 20 4e 61 43 6c 20 53 44 4b  current NaCl SDK
01b0: 20 74 61 72 67 65 74 22 20 3e 26 32 0a 0a 09 65   target" >&2...e
01c0: 78 69 74 20 31 0a 66 69 0a 0a 69 66 20 5b 20 21  xit 1.fi..if [ !
01d0: 20 2d 64 20 22 24 7b 4e 41 43 4c 5f 53 44 4b 5f   -d "${NACL_SDK_
01e0: 52 4f 4f 54 7d 2f 74 6f 6f 6c 63 68 61 69 6e 22  ROOT}/toolchain"
01f0: 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22   ]; then..echo "
0200: 65 72 72 6f 72 3a 20 49 6e 76 61 6c 69 64 20 4e  error: Invalid N
0210: 41 43 4c 5f 53 44 4b 5f 52 4f 4f 54 2c 20 6e 6f  ACL_SDK_ROOT, no
0220: 74 20 66 6f 75 6e 64 3a 20 24 7b 4e 41 43 4c 5f  t found: ${NACL_
0230: 53 44 4b 5f 52 4f 4f 54 7d 2f 74 6f 6f 6c 63 68  SDK_ROOT}/toolch
0240: 61 69 6e 22 20 3e 26 32 0a 0a 09 65 78 69 74 20  ain" >&2...exit 
0250: 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f 6e 20 64  1.fi..function d
0260: 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09 6c 6f 63  ownload() {..loc
0270: 61 6c 20 75 72 6c 20 66 69 6c 65 20 68 61 73 68  al url file hash
0280: 0a 09 6c 6f 63 61 6c 20 68 61 73 68 4d 65 74 68  ..local hashMeth
0290: 6f 64 0a 09 6c 6f 63 61 6c 20 63 68 6b 48 61 73  od..local chkHas
02a0: 68 0a 0a 09 75 72 6c 3d 22 24 31 22 0a 09 66 69  h...url="$1"..fi
02b0: 6c 65 3d 22 24 32 22 0a 09 68 61 73 68 3d 22 24  le="$2"..hash="$
02c0: 33 22 0a 0a 09 69 66 20 5b 20 2d 66 20 22 24 7b  3"...if [ -f "${
02d0: 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  file}" ]; then..
02e0: 09 72 65 74 75 72 6e 20 30 0a 09 66 69 0a 0a 09  .return 0..fi...
02f0: 6d 6b 64 69 72 20 2d 70 20 22 24 28 64 69 72 6e  mkdir -p "$(dirn
0300: 61 6d 65 20 22 24 7b 66 69 6c 65 7d 22 29 22 0a  ame "${file}")".
0310: 0a 09 68 61 73 68 4d 65 74 68 6f 64 3d 27 73 68  ..hashMethod='sh
0320: 61 32 35 36 27 0a 0a 09 72 6d 20 2d 66 20 22 24  a256'...rm -f "$
0330: 7b 66 69 6c 65 7d 2e 6e 65 77 22 0a 09 77 67 65  {file}.new"..wge
0340: 74 20 2d 2d 68 65 61 64 65 72 20 22 58 2d 43 61  t --header "X-Ca
0350: 63 68 65 2d 55 52 4c 3a 20 24 7b 75 72 6c 7d 22  che-URL: ${url}"
0360: 20 2d 4f 20 22 24 7b 66 69 6c 65 7d 2e 6e 65 77   -O "${file}.new
0370: 22 20 22 68 74 74 70 3a 2f 2f 68 61 73 68 63 61  " "http://hashca
0380: 63 68 65 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 24  che.rkeene.org/$
0390: 7b 68 61 73 68 4d 65 74 68 6f 64 7d 2f 24 7b 68  {hashMethod}/${h
03a0: 61 73 68 7d 22 20 7c 7c 20 5c 0a 09 09 77 67 65  ash}" || \...wge
03b0: 74 20 2d 4f 20 22 24 7b 66 69 6c 65 7d 2e 6e 65  t -O "${file}.ne
03c0: 77 22 20 22 24 7b 75 72 6c 7d 22 20 7c 7c 20 5c  w" "${url}" || \
03d0: 0a 09 09 72 65 74 75 72 6e 20 31 0a 0a 09 63 68  ...return 1...ch
03e0: 6b 48 61 73 68 3d 22 24 28 6f 70 65 6e 73 73 6c  kHash="$(openssl
03f0: 20 22 24 7b 68 61 73 68 4d 65 74 68 6f 64 7d 22   "${hashMethod}"
0400: 20 22 24 7b 66 69 6c 65 7d 2e 6e 65 77 22 20 7c   "${file}.new" |
0410: 20 73 65 64 20 27 73 40 2e 2a 3d 20 2a 40 40 27   sed 's@.*= *@@'
0420: 29 22 0a 0a 09 69 66 20 5b 20 22 24 7b 63 68 6b  )"...if [ "${chk
0430: 48 61 73 68 7d 22 20 21 3d 20 22 24 7b 68 61 73  Hash}" != "${has
0440: 68 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  h}" ]; then...ec
0450: 68 6f 20 22 65 72 72 6f 72 3a 20 43 68 65 63 6b  ho "error: Check
0460: 73 75 6d 20 6d 69 73 6d 61 74 63 68 3a 20 47 6f  sum mismatch: Go
0470: 74 3a 20 24 7b 63 68 6b 48 61 73 68 7d 3b 20 45  t: ${chkHash}; E
0480: 78 70 65 63 74 65 64 3a 20 24 7b 68 61 73 68 7d  xpected: ${hash}
0490: 22 20 3e 26 32 0a 0a 09 09 72 65 74 75 72 6e 20  " >&2....return 
04a0: 31 0a 09 66 69 0a 0a 09 6d 76 20 22 24 7b 66 69  1..fi...mv "${fi
04b0: 6c 65 7d 2e 6e 65 77 22 20 22 24 7b 66 69 6c 65  le}.new" "${file
04c0: 7d 22 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a  }"...return 0.}.
04d0: 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74 72 61 63  .function extrac
04e0: 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 66 69 6c  t() {..local fil
04f0: 65 20 64 69 72 65 63 74 6f 72 79 0a 0a 09 66 69  e directory...fi
0500: 6c 65 3d 22 24 31 22 0a 09 64 69 72 65 63 74 6f  le="$1"..directo
0510: 72 79 3d 22 24 32 22 0a 0a 09 69 66 20 5b 20 21  ry="$2"...if [ !
0520: 20 2d 66 20 22 24 7b 66 69 6c 65 7d 22 20 5d 3b   -f "${file}" ];
0530: 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 65 72   then...echo "er
0540: 72 6f 72 3a 20 55 6e 61 62 6c 65 20 74 6f 20 65  ror: Unable to e
0550: 78 74 72 61 63 74 20 5c 22 24 7b 66 69 6c 65 7d  xtract \"${file}
0560: 5c 22 22 20 3e 26 32 0a 0a 09 09 72 65 74 75 72  \"" >&2....retur
0570: 6e 20 31 0a 09 66 69 0a 0a 09 72 6d 20 2d 72 66  n 1..fi...rm -rf
0580: 20 22 24 7b 64 69 72 65 63 74 6f 72 79 7d 22 0a   "${directory}".
0590: 0a 09 6d 6b 64 69 72 20 2d 70 20 22 24 7b 64 69  ..mkdir -p "${di
05a0: 72 65 63 74 6f 72 79 7d 22 20 7c 7c 20 72 65 74  rectory}" || ret
05b0: 75 72 6e 20 31 0a 09 28 0a 09 09 63 64 20 22 24  urn 1..(...cd "$
05c0: 7b 64 69 72 65 63 74 6f 72 79 7d 22 20 7c 7c 20  {directory}" || 
05d0: 65 78 69 74 20 31 0a 0a 09 09 63 61 73 65 20 22  exit 1....case "
05e0: 24 7b 66 69 6c 65 7d 22 20 69 6e 0a 09 09 09 2a  ${file}" in....*
05f0: 2e 74 61 72 2e 62 7a 32 7c 2a 2e 62 7a 32 29 0a  .tar.bz2|*.bz2).
0600: 09 09 09 09 62 7a 69 70 32 20 2d 64 63 20 7c 20  ....bzip2 -dc | 
0610: 74 61 72 20 2d 78 66 20 2d 20 7c 7c 20 65 78 69  tar -xf - || exi
0620: 74 20 31 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2e  t 1.....;;....*.
0630: 74 61 72 2e 67 7a 7c 2a 2e 74 67 7a 29 0a 09 09  tar.gz|*.tgz)...
0640: 09 09 67 7a 69 70 20 2d 64 63 20 7c 20 74 61 72  ..gzip -dc | tar
0650: 20 2d 78 66 20 2d 20 7c 7c 20 65 78 69 74 20 31   -xf - || exit 1
0660: 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2e 74 61 72  .....;;....*.tar
0670: 2e 78 7a 7c 2a 2e 74 78 7a 29 0a 09 09 09 09 78  .xz|*.txz).....x
0680: 7a 20 2d 64 63 20 7c 20 74 61 72 20 2d 78 66 20  z -dc | tar -xf 
0690: 2d 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 09  - || exit 1.....
06a0: 3b 3b 0a 09 09 09 2a 29 0a 09 09 09 09 65 63 68  ;;....*).....ech
06b0: 6f 20 22 65 72 72 6f 72 3a 20 44 6f 6e 27 74 20  o "error: Don't 
06c0: 6b 6e 6f 77 20 77 68 61 74 20 74 6f 20 64 6f 20  know what to do 
06d0: 77 69 74 68 20 5c 22 24 7b 66 69 6c 65 7d 5c 22  with \"${file}\"
06e0: 22 20 3e 26 32 0a 0a 09 09 09 09 65 78 69 74 20  " >&2......exit 
06f0: 31 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a  1.....;;...esac.
0700: 0a 09 09 69 66 20 5b 20 2d 64 20 22 24 28 65 63  ...if [ -d "$(ec
0710: 68 6f 20 2a 29 22 20 5d 3b 20 74 68 65 6e 0a 09  ho *)" ]; then..
0720: 09 09 6d 76 20 2a 2f 2a 20 2e 20 3e 2f 64 65 76  ..mv */* . >/dev
0730: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0740: 6c 0a 09 09 66 69 0a 09 29 20 3c 20 22 24 7b 66  l...fi..) < "${f
0750: 69 6c 65 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20  ile}" || return 
0760: 31 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a  1...return 0.}..
0770: 66 75 6e 63 74 69 6f 6e 20 6d 61 6b 65 28 29 20  function make() 
0780: 7b 0a 09 22 24 7b 4d 41 4b 45 3a 2d 24 28 77 68  {.."${MAKE:-$(wh
0790: 69 63 68 20 6d 61 6b 65 29 7d 22 20 22 24 40 22  ich make)}" "$@"
07a0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69  .}..function bui
07b0: 6c 64 4c 69 62 55 53 42 28 29 20 7b 0a 09 6c 6f  ldLibUSB() {..lo
07c0: 63 61 6c 20 76 65 72 73 69 6f 6e 20 75 72 6c 20  cal version url 
07d0: 70 6b 67 20 73 68 61 32 35 36 20 63 6f 6e 66 69  pkg sha256 confi
07e0: 67 75 72 65 5f 65 78 74 72 61 0a 09 6c 6f 63 61  gure_extra..loca
07f0: 6c 20 61 72 63 68 69 76 65 20 77 6f 72 6b 64 69  l archive workdi
0800: 72 20 69 6e 73 74 64 69 72 0a 0a 09 70 6b 67 3d  r instdir...pkg=
0810: 27 6c 69 62 75 73 62 27 0a 09 76 65 72 73 69 6f  'libusb'..versio
0820: 6e 3d 27 31 2e 30 2e 39 27 0a 09 75 72 6c 3d 22  n='1.0.9'..url="
0830: 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65 66 6f 72  http://sourcefor
0840: 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63 74 73 2f  ge.net/projects/
0850: 6c 69 62 75 73 62 2f 66 69 6c 65 73 2f 6c 69 62  libusb/files/lib
0860: 75 73 62 2d 31 2e 30 2f 6c 69 62 75 73 62 2d 24  usb-1.0/libusb-$
0870: 7b 76 65 72 73 69 6f 6e 7d 2f 6c 69 62 75 73 62  {version}/libusb
0880: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e  -${version}.tar.
0890: 62 7a 32 22 0a 09 73 68 61 32 35 36 3d 27 65 39  bz2"..sha256='e9
08a0: 32 30 65 65 64 63 32 64 30 36 62 30 39 36 30 36  20eedc2d06b09606
08b0: 36 31 31 63 39 39 65 63 37 33 30 34 34 31 33 63  611c99ec7304413c
08c0: 36 37 38 34 63 62 61 36 65 33 33 39 32 38 65 37  6784cba6e33928e7
08d0: 38 32 34 33 64 33 32 33 31 39 35 66 39 62 27 0a  8243d323195f9b'.
08e0: 09 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  .configure_extra
08f0: 3d 28 2d 2d 64 69 73 61 62 6c 65 2d 73 68 61 72  =(--disable-shar
0900: 65 64 20 2d 2d 65 6e 61 62 6c 65 2d 73 74 61 74  ed --enable-stat
0910: 69 63 20 2d 2d 77 69 74 68 2d 70 69 63 20 22 24  ic --with-pic "$
0920: 7b 67 6c 6f 62 61 6c 5f 63 6f 6e 66 69 67 75 72  {global_configur
0930: 65 5f 65 78 74 72 61 5b 40 5d 7d 22 29 0a 0a 09  e_extra[@]}")...
0940: 61 72 63 68 69 76 65 3d 22 61 72 63 68 69 76 65  archive="archive
0950: 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f  /${pkg}-${versio
0960: 6e 7d 2e 74 61 72 2e 62 7a 32 22 0a 09 77 6f 72  n}.tar.bz2"..wor
0970: 6b 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b  kdir="workdir-${
0980: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0990: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
09a0: 4d 7d 2e 62 75 69 6c 64 22 0a 09 69 6e 73 74 64  M}.build"..instd
09b0: 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41  ir="workdir-${RA
09c0: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
09d0: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
09e0: 2e 69 6e 73 74 22 0a 0a 09 64 6f 77 6e 6c 6f 61  .inst"...downloa
09f0: 64 20 22 24 7b 75 72 6c 7d 22 20 22 24 7b 61 72  d "${url}" "${ar
0a00: 63 68 69 76 65 7d 22 20 22 24 7b 73 68 61 32 35  chive}" "${sha25
0a10: 36 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a  6}" || return 1.
0a20: 09 65 78 74 72 61 63 74 20 22 24 7b 61 72 63 68  .extract "${arch
0a30: 69 76 65 7d 22 20 22 24 7b 77 6f 72 6b 64 69 72  ive}" "${workdir
0a40: 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a  }" || return 1..
0a50: 09 28 0a 09 09 6d 6b 64 69 72 20 22 24 7b 69 6e  .(...mkdir "${in
0a60: 73 74 64 69 72 7d 22 0a 0a 09 09 69 6e 73 74 64  stdir}"....instd
0a70: 69 72 3d 22 24 28 63 64 20 22 24 7b 69 6e 73 74  ir="$(cd "${inst
0a80: 64 69 72 7d 22 20 26 26 20 70 77 64 29 22 20 7c  dir}" && pwd)" |
0a90: 7c 20 65 78 69 74 20 31 0a 0a 09 09 63 64 20 22  | exit 1....cd "
0aa0: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
0ab0: 78 69 74 20 31 0a 0a 09 09 2e 2f 63 6f 6e 66 69  xit 1...../confi
0ac0: 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d 27 27  gure --prefix=''
0ad0: 20 22 24 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78   "${configure_ex
0ae0: 74 72 61 5b 40 5d 7d 22 20 7c 7c 20 65 78 69 74  tra[@]}" || exit
0af0: 20 31 0a 09 09 6d 61 6b 65 20 56 3d 31 20 7c 7c   1...make V=1 ||
0b00: 20 65 78 69 74 20 31 0a 09 09 6d 61 6b 65 20 56   exit 1...make V
0b10: 3d 31 20 44 45 53 54 44 49 52 3d 22 24 7b 69 6e  =1 DESTDIR="${in
0b20: 73 74 64 69 72 7d 22 20 69 6e 73 74 61 6c 6c 20  stdir}" install 
0b30: 7c 7c 20 65 78 69 74 20 31 0a 09 29 20 7c 7c 20  || exit 1..) || 
0b40: 72 65 74 75 72 6e 20 31 0a 0a 09 72 6d 20 2d 72  return 1...rm -r
0b50: 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 0a  f "${workdir}"..
0b60: 09 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74  .cackeyChromeExt
0b70: 4c 69 62 55 53 42 44 69 72 3d 22 24 28 63 64 20  LibUSBDir="$(cd 
0b80: 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 26 26 20  "${instdir}" && 
0b90: 70 77 64 29 22 20 7c 7c 20 72 65 74 75 72 6e 20  pwd)" || return 
0ba0: 31 0a 09 65 78 70 6f 72 74 20 4c 49 42 55 53 42  1..export LIBUSB
0bb0: 5f 4c 49 42 53 3d 22 2d 4c 24 7b 63 61 63 6b 65  _LIBS="-L${cacke
0bc0: 79 43 68 72 6f 6d 65 45 78 74 4c 69 62 55 53 42  yChromeExtLibUSB
0bd0: 44 69 72 7d 2f 6c 69 62 20 2d 6c 75 73 62 2d 31  Dir}/lib -lusb-1
0be0: 2e 30 20 2d 6c 72 74 20 2d 70 74 68 72 65 61 64  .0 -lrt -pthread
0bf0: 22 0a 09 65 78 70 6f 72 74 20 4c 49 42 55 53 42  "..export LIBUSB
0c00: 5f 43 46 4c 41 47 53 3d 22 2d 49 24 7b 63 61 63  _CFLAGS="-I${cac
0c10: 6b 65 79 43 68 72 6f 6d 65 45 78 74 4c 69 62 55  keyChromeExtLibU
0c20: 53 42 44 69 72 7d 2f 69 6e 63 6c 75 64 65 2f 6c  SBDir}/include/l
0c30: 69 62 75 73 62 2d 31 2e 30 22 0a 0a 09 72 65 74  ibusb-1.0"...ret
0c40: 75 72 6e 20 30 0a 7d 0a 0a 66 75 6e 63 74 69 6f  urn 0.}..functio
0c50: 6e 20 62 75 69 6c 64 43 43 49 44 28 29 20 7b 0a  n buildCCID() {.
0c60: 09 6c 6f 63 61 6c 20 76 65 72 73 69 6f 6e 20 75  .local version u
0c70: 72 6c 20 70 6b 67 20 73 68 61 32 35 36 20 63 6f  rl pkg sha256 co
0c80: 6e 66 69 67 75 72 65 5f 65 78 74 72 61 0a 09 6c  nfigure_extra..l
0c90: 6f 63 61 6c 20 61 72 63 68 69 76 65 20 77 6f 72  ocal archive wor
0ca0: 6b 64 69 72 20 69 6e 73 74 64 69 72 0a 0a 09 70  kdir instdir...p
0cb0: 6b 67 3d 27 63 63 69 64 27 0a 09 76 65 72 73 69  kg='ccid'..versi
0cc0: 6f 6e 3d 27 31 2e 34 2e 32 32 27 0a 09 75 72 6c  on='1.4.22'..url
0cd0: 3d 22 68 74 74 70 73 3a 2f 2f 61 6c 69 6f 74 68  ="https://alioth
0ce0: 2e 64 65 62 69 61 6e 2e 6f 72 67 2f 66 72 73 2f  .debian.org/frs/
0cf0: 64 6f 77 6e 6c 6f 61 64 2e 70 68 70 2f 66 69 6c  download.php/fil
0d00: 65 2f 34 31 36 32 2f 63 63 69 64 2d 24 7b 76 65  e/4162/ccid-${ve
0d10: 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a 32 22 0a  rsion}.tar.bz2".
0d20: 09 73 68 61 32 35 36 3d 27 39 63 35 63 38 62 65  .sha256='9c5c8be
0d30: 34 36 35 62 36 64 33 33 33 31 36 62 65 37 61 37  465b6d33316be7a7
0d40: 65 61 37 32 30 63 32 34 61 37 37 36 65 32 64 37  ea720c24a776e2d7
0d50: 36 62 65 39 30 37 32 31 31 36 64 32 38 66 63 39  6be9072116d28fc9
0d60: 61 64 66 35 38 63 31 30 36 27 0a 09 63 6f 6e 66  adf58c106'..conf
0d70: 69 67 75 72 65 5f 65 78 74 72 61 3d 28 0a 09 09  igure_extra=(...
0d80: 2d 2d 77 69 74 68 2d 70 69 63 0a 09 09 2d 2d 64  --with-pic...--d
0d90: 69 73 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d  isable-shared --
0da0: 65 6e 61 62 6c 65 2d 73 74 61 74 69 63 20 2d 2d  enable-static --
0db0: 65 6e 61 62 6c 65 2d 75 73 62 0a 09 09 2d 2d 65  enable-usb...--e
0dc0: 6e 61 62 6c 65 2d 75 73 62 64 72 6f 70 64 69 72  nable-usbdropdir
0dd0: 3d 2f 64 72 69 76 65 72 73 0a 09 09 22 24 7b 67  =/drivers..."${g
0de0: 6c 6f 62 61 6c 5f 63 6f 6e 66 69 67 75 72 65 5f  lobal_configure_
0df0: 65 78 74 72 61 5b 40 5d 7d 22 0a 09 29 0a 0a 09  extra[@]}"..)...
0e00: 61 72 63 68 69 76 65 3d 22 61 72 63 68 69 76 65  archive="archive
0e10: 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f  /${pkg}-${versio
0e20: 6e 7d 2e 74 61 72 2e 62 7a 32 22 0a 09 77 6f 72  n}.tar.bz2"..wor
0e30: 6b 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b  kdir="workdir-${
0e40: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0e50: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
0e60: 4d 7d 2e 62 75 69 6c 64 22 0a 09 69 6e 73 74 64  M}.build"..instd
0e70: 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41  ir="workdir-${RA
0e80: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
0e90: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0ea0: 2e 69 6e 73 74 22 0a 0a 09 64 6f 77 6e 6c 6f 61  .inst"...downloa
0eb0: 64 20 22 24 7b 75 72 6c 7d 22 20 22 24 7b 61 72  d "${url}" "${ar
0ec0: 63 68 69 76 65 7d 22 20 22 24 7b 73 68 61 32 35  chive}" "${sha25
0ed0: 36 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a  6}" || return 1.
0ee0: 09 65 78 74 72 61 63 74 20 22 24 7b 61 72 63 68  .extract "${arch
0ef0: 69 76 65 7d 22 20 22 24 7b 77 6f 72 6b 64 69 72  ive}" "${workdir
0f00: 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a  }" || return 1..
0f10: 09 28 0a 09 09 6d 6b 64 69 72 20 22 24 7b 69 6e  .(...mkdir "${in
0f20: 73 74 64 69 72 7d 22 0a 0a 09 09 69 6e 73 74 64  stdir}"....instd
0f30: 69 72 3d 22 24 28 63 64 20 22 24 7b 69 6e 73 74  ir="$(cd "${inst
0f40: 64 69 72 7d 22 20 26 26 20 70 77 64 29 22 20 7c  dir}" && pwd)" |
0f50: 7c 20 65 78 69 74 20 31 0a 0a 09 09 63 64 20 22  | exit 1....cd "
0f60: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
0f70: 78 69 74 20 31 0a 0a 09 09 2e 2f 63 6f 6e 66 69  xit 1...../confi
0f80: 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d 27 27  gure --prefix=''
0f90: 20 22 24 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78   "${configure_ex
0fa0: 74 72 61 5b 40 5d 7d 22 20 7c 7c 20 65 78 69 74  tra[@]}" || exit
0fb0: 20 31 0a 0a 09 09 6d 61 6b 65 20 56 3d 31 20 7c   1....make V=1 |
0fc0: 7c 20 65 78 69 74 20 31 0a 0a 09 09 6d 6b 64 69  | exit 1....mkdi
0fd0: 72 20 22 24 7b 69 6e 73 74 64 69 72 7d 2f 6c 69  r "${instdir}/li
0fe0: 62 22 0a 09 09 63 70 20 73 72 63 2f 2e 6c 69 62  b"...cp src/.lib
0ff0: 73 2f 6c 69 62 63 63 69 64 2e 61 20 22 24 7b 69  s/libccid.a "${i
1000: 6e 73 74 64 69 72 7d 2f 6c 69 62 22 0a 0a 09 09  nstdir}/lib"....
1010: 6d 6b 64 69 72 20 22 24 7b 69 6e 73 74 64 69 72  mkdir "${instdir
1020: 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 2e 2f 73  }/include"..../s
1030: 72 63 2f 63 72 65 61 74 65 5f 49 6e 66 6f 5f 70  rc/create_Info_p
1040: 6c 69 73 74 2e 70 6c 20 2e 2f 72 65 61 64 65 72  list.pl ./reader
1050: 73 2f 73 75 70 70 6f 72 74 65 64 5f 72 65 61 64  s/supported_read
1060: 65 72 73 2e 74 78 74 20 73 72 63 2f 49 6e 66 6f  ers.txt src/Info
1070: 2e 70 6c 69 73 74 2e 73 72 63 20 2d 2d 74 61 72  .plist.src --tar
1080: 67 65 74 3d 6c 69 62 63 63 69 64 2e 73 6f 20 2d  get=libccid.so -
1090: 2d 76 65 72 73 69 6f 6e 3d 31 2e 30 2e 30 20 7c  -version=1.0.0 |
10a0: 20 5c 0a 09 09 09 73 65 64 20 27 2f 3c 6b 65 79   \....sed '/<key
10b0: 3e 69 66 64 44 72 69 76 65 72 4f 70 74 69 6f 6e  >ifdDriverOption
10c0: 73 2f 20 7b 6e 3b 63 20 5c 27 24 27 5c 6e 27 27  s/ {n;c \'$'\n''
10d0: 3c 73 74 72 69 6e 67 3e 30 78 30 30 30 34 3c 2f  <string>0x0004</
10e0: 73 74 72 69 6e 67 3e 27 24 27 5c 6e 27 27 70 7d  string>'$'\n''p}
10f0: 27 20 7c 20 5c 0a 09 09 09 6f 64 20 2d 74 20 78  ' | \....od -t x
1100: 31 20 2d 76 20 7c 20 73 65 64 20 27 73 40 5e 5b  1 -v | sed 's@^[
1110: 5e 20 5d 2a 20 40 40 3b 73 40 20 40 40 67 3b 73  ^ ]* @@;s@ @@g;s
1120: 40 2e 2e 40 5c 5c 78 26 40 67 3b 24 20 64 3b 73  @..@\\x&@g;$ d;s
1130: 40 5e 40 22 40 3b 73 40 24 40 22 40 27 20 3e 20  @^@"@;s@$@"@' > 
1140: 22 24 7b 69 6e 73 74 64 69 72 7d 2f 69 6e 63 6c  "${instdir}/incl
1150: 75 64 65 2f 49 6e 66 6f 2e 70 6c 69 73 74 2e 68  ude/Info.plist.h
1160: 22 0a 09 29 20 7c 7c 20 72 65 74 75 72 6e 20 31  "..) || return 1
1170: 0a 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72  ...rm -rf "${wor
1180: 6b 64 69 72 7d 22 0a 0a 09 63 61 63 6b 65 79 43  kdir}"...cackeyC
1190: 68 72 6f 6d 65 45 78 74 43 43 49 44 44 69 72 3d  hromeExtCCIDDir=
11a0: 22 24 28 63 64 20 22 24 7b 69 6e 73 74 64 69 72  "$(cd "${instdir
11b0: 7d 22 20 26 26 20 70 77 64 29 22 20 7c 7c 20 72  }" && pwd)" || r
11c0: 65 74 75 72 6e 20 31 0a 0a 09 72 65 74 75 72 6e  eturn 1...return
11d0: 20 30 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 62   0.}..function b
11e0: 75 69 6c 64 50 43 53 43 4c 69 74 65 28 29 20 7b  uildPCSCLite() {
11f0: 0a 09 6c 6f 63 61 6c 20 76 65 72 73 69 6f 6e 20  ..local version 
1200: 75 72 6c 20 70 6b 67 20 73 68 61 32 35 36 20 63  url pkg sha256 c
1210: 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61 0a 09  onfigure_extra..
1220: 6c 6f 63 61 6c 20 61 72 63 68 69 76 65 20 77 6f  local archive wo
1230: 72 6b 64 69 72 20 69 6e 73 74 64 69 72 0a 0a 09  rkdir instdir...
1240: 62 75 69 6c 64 4c 69 62 55 53 42 20 7c 7c 20 72  buildLibUSB || r
1250: 65 74 75 72 6e 20 31 0a 0a 09 70 6b 67 3d 27 70  eturn 1...pkg='p
1260: 63 73 63 2d 6c 69 74 65 27 0a 09 76 65 72 73 69  csc-lite'..versi
1270: 6f 6e 3d 27 31 2e 38 2e 31 35 27 0a 09 75 72 6c  on='1.8.15'..url
1280: 3d 22 68 74 74 70 73 3a 2f 2f 61 6c 69 6f 74 68  ="https://alioth
1290: 2e 64 65 62 69 61 6e 2e 6f 72 67 2f 66 72 73 2f  .debian.org/frs/
12a0: 64 6f 77 6e 6c 6f 61 64 2e 70 68 70 2f 66 69 6c  download.php/fil
12b0: 65 2f 34 31 35 37 2f 70 63 73 63 2d 6c 69 74 65  e/4157/pcsc-lite
12c0: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e  -${version}.tar.
12d0: 62 7a 32 22 0a 09 73 68 61 32 35 36 3d 27 61 64  bz2"..sha256='ad
12e0: 38 62 31 66 33 64 32 63 35 39 64 33 61 39 36 36  8b1f3d2c59d3a966
12f0: 63 62 32 30 33 66 63 37 34 35 38 38 36 32 39 63  cb203fc74588629c
1300: 34 61 35 66 61 33 30 66 38 61 64 39 30 30 35 65  4a5fa30f8ad9005e
1310: 30 36 65 66 37 61 61 34 34 35 64 33 34 31 27 0a  06ef7aa445d341'.
1320: 09 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  .configure_extra
1330: 3d 28 0a 09 09 2d 2d 64 69 73 61 62 6c 65 2d 73  =(...--disable-s
1340: 68 61 72 65 64 20 2d 2d 65 6e 61 62 6c 65 2d 73  hared --enable-s
1350: 74 61 74 69 63 20 2d 2d 65 6e 61 62 6c 65 2d 75  tatic --enable-u
1360: 73 62 20 2d 2d 64 69 73 61 62 6c 65 2d 6c 69 62  sb --disable-lib
1370: 75 64 65 76 20 2d 2d 64 69 73 61 62 6c 65 2d 70  udev --disable-p
1380: 6f 6c 6b 69 74 20 2d 2d 77 69 74 68 2d 70 69 63  olkit --with-pic
1390: 0a 09 09 22 24 7b 67 6c 6f 62 61 6c 5f 63 6f 6e  ..."${global_con
13a0: 66 69 67 75 72 65 5f 65 78 74 72 61 5b 40 5d 7d  figure_extra[@]}
13b0: 22 0a 09 29 0a 0a 09 61 72 63 68 69 76 65 3d 22  "..)...archive="
13c0: 61 72 63 68 69 76 65 2f 24 7b 70 6b 67 7d 2d 24  archive/${pkg}-$
13d0: 7b 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a  {version}.tar.bz
13e0: 32 22 0a 09 77 6f 72 6b 64 69 72 3d 22 77 6f 72  2"..workdir="wor
13f0: 6b 64 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  kdir-${RANDOM}${
1400: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
1410: 24 7b 52 41 4e 44 4f 4d 7d 2e 62 75 69 6c 64 22  ${RANDOM}.build"
1420: 0a 09 69 6e 73 74 64 69 72 3d 22 77 6f 72 6b 64  ..instdir="workd
1430: 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41  ir-${RANDOM}${RA
1440: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
1450: 52 41 4e 44 4f 4d 7d 2e 69 6e 73 74 22 0a 0a 09  RANDOM}.inst"...
1460: 64 6f 77 6e 6c 6f 61 64 20 22 24 7b 75 72 6c 7d  download "${url}
1470: 22 20 22 24 7b 61 72 63 68 69 76 65 7d 22 20 22  " "${archive}" "
1480: 24 7b 73 68 61 32 35 36 7d 22 20 7c 7c 20 72 65  ${sha256}" || re
1490: 74 75 72 6e 20 31 0a 09 65 78 74 72 61 63 74 20  turn 1..extract 
14a0: 22 24 7b 61 72 63 68 69 76 65 7d 22 20 22 24 7b  "${archive}" "${
14b0: 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 72 65 74  workdir}" || ret
14c0: 75 72 6e 20 31 0a 0a 09 28 0a 09 09 6d 6b 64 69  urn 1...(...mkdi
14d0: 72 20 22 24 7b 69 6e 73 74 64 69 72 7d 22 0a 0a  r "${instdir}"..
14e0: 09 09 69 6e 73 74 64 69 72 3d 22 24 28 63 64 20  ..instdir="$(cd 
14f0: 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 26 26 20  "${instdir}" && 
1500: 70 77 64 29 22 20 7c 7c 20 65 78 69 74 20 31 0a  pwd)" || exit 1.
1510: 0a 09 09 63 64 20 22 24 7b 77 6f 72 6b 64 69 72  ...cd "${workdir
1520: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09  }" || exit 1....
1530: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 70 72  ./configure --pr
1540: 65 66 69 78 3d 27 27 20 2d 2d 73 62 69 6e 64 69  efix='' --sbindi
1550: 72 3d 22 2f 62 69 6e 22 20 22 24 7b 63 6f 6e 66  r="/bin" "${conf
1560: 69 67 75 72 65 5f 65 78 74 72 61 5b 40 5d 7d 22  igure_extra[@]}"
1570: 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 6d 61 6b   || exit 1...mak
1580: 65 20 56 3d 31 20 7c 7c 20 65 78 69 74 20 31 0a  e V=1 || exit 1.
1590: 09 09 6d 61 6b 65 20 56 3d 31 20 44 45 53 54 44  ..make V=1 DESTD
15a0: 49 52 3d 22 24 7b 69 6e 73 74 64 69 72 7d 22 20  IR="${instdir}" 
15b0: 69 6e 73 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20  install || exit 
15c0: 31 0a 09 29 20 7c 7c 20 72 65 74 75 72 6e 20 31  1..) || return 1
15d0: 0a 0a 09 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  ...cackeyChromeE
15e0: 78 74 50 43 53 43 4c 69 74 65 44 69 72 3d 22 24  xtPCSCLiteDir="$
15f0: 28 63 64 20 22 24 7b 69 6e 73 74 64 69 72 7d 22  (cd "${instdir}"
1600: 20 26 26 20 70 77 64 29 22 0a 09 65 78 70 6f 72   && pwd)"..expor
1610: 74 20 50 43 53 43 5f 43 46 4c 41 47 53 3d 22 2d  t PCSC_CFLAGS="-
1620: 49 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  I${cackeyChromeE
1630: 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f 69  xtPCSCLiteDir}/i
1640: 6e 63 6c 75 64 65 2f 50 43 53 43 22 0a 09 65 78  nclude/PCSC"..ex
1650: 70 6f 72 74 20 50 43 53 43 5f 4c 49 42 53 3d 22  port PCSC_LIBS="
1660: 2d 4c 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65  -L${cackeyChrome
1670: 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f  ExtPCSCLiteDir}/
1680: 6c 69 62 20 2d 6c 70 63 73 63 6c 69 74 65 20 2d  lib -lpcsclite -
1690: 70 74 68 72 65 61 64 22 0a 0a 09 62 75 69 6c 64  pthread"...build
16a0: 43 43 49 44 20 7c 7c 20 72 65 74 75 72 6e 20 31  CCID || return 1
16b0: 0a 0a 09 72 6d 20 2d 72 66 20 22 24 7b 69 6e 73  ...rm -rf "${ins
16c0: 74 64 69 72 7d 22 0a 09 75 6e 73 65 74 20 50 43  tdir}"..unset PC
16d0: 53 43 5f 43 46 4c 41 47 53 20 50 43 53 43 5f 4c  SC_CFLAGS PCSC_L
16e0: 49 42 53 20 63 61 63 6b 65 79 43 68 72 6f 6d 65  IBS cackeyChrome
16f0: 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 0a 0a  ExtPCSCLiteDir..
1700: 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b 64  .rm -rf "${workd
1710: 69 72 7d 22 0a 09 65 78 74 72 61 63 74 20 22 24  ir}"..extract "$
1720: 7b 61 72 63 68 69 76 65 7d 22 20 22 24 7b 77 6f  {archive}" "${wo
1730: 72 6b 64 69 72 7d 22 20 7c 7c 20 72 65 74 75 72  rkdir}" || retur
1740: 6e 20 31 0a 0a 09 28 0a 09 09 6d 6b 64 69 72 20  n 1...(...mkdir 
1750: 22 24 7b 69 6e 73 74 64 69 72 7d 22 0a 0a 09 09  "${instdir}"....
1760: 69 6e 73 74 64 69 72 3d 22 24 28 63 64 20 22 24  instdir="$(cd "$
1770: 7b 69 6e 73 74 64 69 72 7d 22 20 26 26 20 70 77  {instdir}" && pw
1780: 64 29 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  d)" || exit 1...
1790: 09 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  .cd "${workdir}"
17a0: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 73 65   || exit 1....se
17b0: 64 20 2d 69 20 27 73 40 5e 70 63 73 63 64 5f 4c  d -i 's@^pcscd_L
17c0: 44 46 4c 41 47 53 5b 5b 3a 73 70 61 63 65 3a 5d  DFLAGS[[:space:]
17d0: 5d 2a 3d 40 26 20 2d 61 6c 6c 2d 73 74 61 74 69  ]*=@& -all-stati
17e0: 63 20 40 27 20 73 72 63 2f 4d 61 6b 65 66 69 6c  c @' src/Makefil
17f0: 65 2e 69 6e 0a 0a 09 09 66 6f 72 20 70 61 74 63  e.in....for patc
1800: 68 46 69 6c 65 20 69 6e 20 22 24 7b 70 61 74 63  hFile in "${patc
1810: 68 44 69 72 7d 22 2f 70 63 73 63 2d 6c 69 74 65  hDir}"/pcsc-lite
1820: 2d 2a 2e 64 69 66 66 3b 20 64 6f 0a 09 09 09 69  -*.diff; do....i
1830: 66 20 5b 20 21 20 2d 66 20 22 24 7b 70 61 74 63  f [ ! -f "${patc
1840: 68 46 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a  hFile}" ]; then.
1850: 09 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09  ....continue....
1860: 66 69 0a 0a 09 09 09 70 61 74 63 68 20 2d 70 31  fi.....patch -p1
1870: 20 3c 20 22 24 7b 70 61 74 63 68 46 69 6c 65 7d   < "${patchFile}
1880: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 64 6f  " || exit 1...do
1890: 6e 65 0a 0a 09 09 63 70 20 22 24 7b 63 61 63 6b  ne....cp "${cack
18a0: 65 79 43 68 72 6f 6d 65 45 78 74 43 43 49 44 44  eyChromeExtCCIDD
18b0: 69 72 7d 2f 69 6e 63 6c 75 64 65 2f 49 6e 66 6f  ir}/include/Info
18c0: 2e 70 6c 69 73 74 2e 68 22 20 73 72 63 2f 20 7c  .plist.h" src/ |
18d0: 7c 20 65 78 69 74 20 31 0a 0a 09 09 65 78 74 72  | exit 1....extr
18e0: 61 44 65 66 69 6e 65 73 3d 27 2d 44 50 43 53 43  aDefines='-DPCSC
18f0: 4c 49 54 45 5f 53 54 41 54 49 43 5f 44 52 49 56  LITE_STATIC_DRIV
1900: 45 52 20 2d 44 49 46 44 48 41 4e 44 4c 45 52 76  ER -DIFDHANDLERv
1910: 33 27 0a 0a 09 09 2e 2f 63 6f 6e 66 69 67 75 72  3'...../configur
1920: 65 20 2d 2d 70 72 65 66 69 78 3d 27 27 20 2d 2d  e --prefix='' --
1930: 73 62 69 6e 64 69 72 3d 22 2f 62 69 6e 22 20 22  sbindir="/bin" "
1940: 24 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72  ${configure_extr
1950: 61 5b 40 5d 7d 22 20 43 46 4c 41 47 53 3d 22 24  a[@]}" CFLAGS="$
1960: 7b 43 46 4c 41 47 53 7d 20 24 7b 65 78 74 72 61  {CFLAGS} ${extra
1970: 44 65 66 69 6e 65 73 7d 22 20 43 50 50 46 4c 41  Defines}" CPPFLA
1980: 47 53 3d 22 24 7b 43 50 50 46 4c 41 47 53 7d 20  GS="${CPPFLAGS} 
1990: 24 7b 65 78 74 72 61 44 65 66 69 6e 65 73 7d 22  ${extraDefines}"
19a0: 20 4c 49 42 53 3d 22 24 7b 4c 49 42 53 7d 20 2d   LIBS="${LIBS} -
19b0: 4c 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  L${cackeyChromeE
19c0: 78 74 43 43 49 44 44 69 72 7d 2f 6c 69 62 20 2d  xtCCIDDir}/lib -
19d0: 6c 63 63 69 64 22 20 7c 7c 20 65 78 69 74 20 31  lccid" || exit 1
19e0: 0a 09 09 6d 61 6b 65 20 56 3d 31 20 7c 7c 20 65  ...make V=1 || e
19f0: 78 69 74 20 31 0a 09 09 6d 61 6b 65 20 56 3d 31  xit 1...make V=1
1a00: 20 44 45 53 54 44 49 52 3d 22 24 7b 69 6e 73 74   DESTDIR="${inst
1a10: 64 69 72 7d 22 20 69 6e 73 74 61 6c 6c 20 7c 7c  dir}" install ||
1a20: 20 65 78 69 74 20 31 0a 09 29 20 7c 7c 20 72 65   exit 1..) || re
1a30: 74 75 72 6e 20 31 0a 0a 09 72 6d 20 2d 72 66 20  turn 1...rm -rf 
1a40: 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  "${cackeyChromeE
1a50: 78 74 4c 69 62 55 53 42 44 69 72 7d 22 0a 09 75  xtLibUSBDir}"..u
1a60: 6e 73 65 74 20 4c 49 42 55 53 42 5f 4c 49 42 53  nset LIBUSB_LIBS
1a70: 20 4c 49 42 55 53 42 5f 43 46 4c 41 47 53 0a 0a   LIBUSB_CFLAGS..
1a80: 09 72 6d 20 2d 72 66 20 22 24 7b 63 61 63 6b 65  .rm -rf "${cacke
1a90: 79 43 68 72 6f 6d 65 45 78 74 43 43 49 44 44 69  yChromeExtCCIDDi
1aa0: 72 7d 22 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77  r}"..rm -rf "${w
1ab0: 6f 72 6b 64 69 72 7d 22 0a 0a 09 63 61 63 6b 65  orkdir}"...cacke
1ac0: 79 43 68 72 6f 6d 65 45 78 74 50 43 53 43 4c 69  yChromeExtPCSCLi
1ad0: 74 65 44 69 72 3d 22 24 28 63 64 20 22 24 7b 69  teDir="$(cd "${i
1ae0: 6e 73 74 64 69 72 7d 22 20 26 26 20 70 77 64 29  nstdir}" && pwd)
1af0: 22 0a 09 65 78 70 6f 72 74 20 50 43 53 43 5f 43  "..export PCSC_C
1b00: 46 4c 41 47 53 3d 22 2d 49 24 7b 63 61 63 6b 65  FLAGS="-I${cacke
1b10: 79 43 68 72 6f 6d 65 45 78 74 50 43 53 43 4c 69  yChromeExtPCSCLi
1b20: 74 65 44 69 72 7d 2f 69 6e 63 6c 75 64 65 2f 50  teDir}/include/P
1b30: 43 53 43 22 0a 09 65 78 70 6f 72 74 20 50 43 53  CSC"..export PCS
1b40: 43 5f 4c 49 42 53 3d 22 2d 4c 24 7b 63 61 63 6b  C_LIBS="-L${cack
1b50: 65 79 43 68 72 6f 6d 65 45 78 74 50 43 53 43 4c  eyChromeExtPCSCL
1b60: 69 74 65 44 69 72 7d 2f 6c 69 62 2f 64 75 6d 6d  iteDir}/lib/dumm
1b70: 79 20 2d 6c 70 63 73 63 6c 69 74 65 22 0a 0a 09  y -lpcsclite"...
1b80: 23 20 43 72 65 61 74 65 20 64 75 6d 6d 79 20 50  # Create dummy P
1b90: 43 2f 53 43 20 6c 69 62 72 61 72 79 20 2d 2d 20  C/SC library -- 
1ba0: 6a 75 73 74 20 65 6e 6f 75 67 68 20 74 6f 20 70  just enough to p
1bb0: 61 73 74 20 43 41 43 4b 65 79 20 6c 69 6e 6b 69  ast CACKey linki
1bc0: 6e 67 20 74 65 73 74 0a 09 6d 6b 64 69 72 20 22  ng test..mkdir "
1bd0: 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78  ${cackeyChromeEx
1be0: 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f 6c 69  tPCSCLiteDir}/li
1bf0: 62 2f 64 75 6d 6d 79 22 20 7c 7c 20 72 65 74 75  b/dummy" || retu
1c00: 72 6e 20 31 0a 09 65 63 68 6f 20 27 76 6f 69 64  rn 1..echo 'void
1c10: 20 53 43 61 72 64 45 73 74 61 62 6c 69 73 68 43   SCardEstablishC
1c20: 6f 6e 74 65 78 74 28 76 6f 69 64 29 20 7b 20 72  ontext(void) { r
1c30: 65 74 75 72 6e 3b 20 7d 3b 20 76 6f 69 64 20 53  eturn; }; void S
1c40: 43 61 72 64 43 6f 6e 6e 65 63 74 28 76 6f 69 64  CardConnect(void
1c50: 29 20 7b 20 72 65 74 75 72 6e 3b 20 7d 27 20 7c  ) { return; }' |
1c60: 20 67 63 63 20 2d 78 20 63 20 2d 20 2d 66 50 49   gcc -x c - -fPI
1c70: 43 20 2d 73 68 61 72 65 64 20 2d 6f 20 22 24 7b  C -shared -o "${
1c80: 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 50  cackeyChromeExtP
1c90: 43 53 43 4c 69 74 65 44 69 72 7d 2f 6c 69 62 2f  CSCLiteDir}/lib/
1ca0: 64 75 6d 6d 79 2f 6c 69 62 70 63 73 63 6c 69 74  dummy/libpcsclit
1cb0: 65 2e 73 6f 22 0a 0a 09 23 20 43 6f 70 79 20 73  e.so"...# Copy s
1cc0: 74 61 74 69 63 61 6c 6c 79 20 6c 69 6e 6b 65 64  tatically linked
1cd0: 20 22 70 63 73 63 64 22 20 6f 75 74 0a 09 63 70   "pcscd" out..cp
1ce0: 20 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65   "${cackeyChrome
1cf0: 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f  ExtPCSCLiteDir}/
1d00: 62 69 6e 2f 70 63 73 63 64 22 20 22 24 7b 6f 75  bin/pcscd" "${ou
1d10: 74 64 69 72 7d 22 20 7c 7c 20 72 65 74 75 72 6e  tdir}" || return
1d20: 20 31 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a   1...return 0.}.
1d30: 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64 43  .function buildC
1d40: 41 43 4b 65 79 28 29 20 7b 0a 09 6c 6f 63 61 6c  ACKey() {..local
1d50: 20 70 6c 61 74 66 6f 72 6d 0a 09 6c 6f 63 61 6c   platform..local
1d60: 20 66 69 6c 65 20 63 6f 70 69 65 64 0a 0a 09 70   file copied...p
1d70: 6c 61 74 66 6f 72 6d 3d 22 24 31 22 0a 09 73 68  latform="$1"..sh
1d80: 69 66 74 0a 0a 09 69 66 20 5b 20 2d 7a 20 22 24  ift...if [ -z "$
1d90: 7b 70 6c 61 74 66 6f 72 6d 7d 22 20 5d 3b 20 74  {platform}" ]; t
1da0: 68 65 6e 0a 09 09 65 63 68 6f 20 27 65 72 72 6f  hen...echo 'erro
1db0: 72 3a 20 50 6c 61 74 66 6f 72 6d 20 6e 6f 74 20  r: Platform not 
1dc0: 73 70 65 63 69 66 69 65 64 27 20 3e 26 32 0a 0a  specified' >&2..
1dd0: 09 09 72 65 74 75 72 6e 20 31 0a 09 66 69 0a 0a  ..return 1..fi..
1de0: 09 28 0a 09 09 63 64 20 2e 2e 2f 2e 2e 20 7c 7c  .(...cd ../.. ||
1df0: 20 65 78 69 74 20 31 0a 0a 09 09 6d 61 6b 65 20   exit 1....make 
1e00: 64 69 73 74 63 6c 65 61 6e 0a 0a 09 09 2e 2f 63  distclean...../c
1e10: 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d  onfigure --with-
1e20: 70 63 73 63 2d 68 65 61 64 65 72 73 3d 22 24 7b  pcsc-headers="${
1e30: 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 50  cackeyChromeExtP
1e40: 43 53 43 4c 69 74 65 44 69 72 7d 2f 69 6e 63 6c  CSCLiteDir}/incl
1e50: 75 64 65 2f 50 43 53 43 22 20 2d 2d 77 69 74 68  ude/PCSC" --with
1e60: 2d 70 63 73 63 2d 6c 69 62 73 3d 22 24 7b 50 43  -pcsc-libs="${PC
1e70: 53 43 5f 4c 49 42 53 7d 22 20 22 24 40 22 20 7c  SC_LIBS}" "$@" |
1e80: 7c 20 65 78 69 74 20 31 0a 09 09 6d 61 6b 65 20  | exit 1...make 
1e90: 7c 7c 20 65 78 69 74 20 31 0a 09 29 20 7c 7c 20  || exit 1..) || 
1ea0: 72 65 74 75 72 6e 20 31 0a 0a 09 63 6f 70 69 65  return 1...copie
1eb0: 64 3d 27 30 27 0a 09 66 6f 72 20 66 69 6c 65 20  d='0'..for file 
1ec0: 69 6e 20 2e 2e 2f 2e 2e 2f 6c 69 62 63 61 63 6b  in ../../libcack
1ed0: 65 79 7b 2c 5f 67 7d 2e 7b 73 6f 2c 64 6c 6c 2c  ey{,_g}.{so,dll,
1ee0: 64 79 6c 69 62 7d 3b 20 64 6f 0a 09 09 69 66 20  dylib}; do...if 
1ef0: 5b 20 2d 66 20 22 24 7b 66 69 6c 65 7d 22 20 5d  [ -f "${file}" ]
1f00: 3b 20 74 68 65 6e 0a 09 09 09 6d 6b 64 69 72 20  ; then....mkdir 
1f10: 2d 70 20 22 24 7b 6f 75 74 64 69 72 7d 2f 24 7b  -p "${outdir}/${
1f20: 70 6c 61 74 66 6f 72 6d 7d 22 0a 0a 09 09 09 63  platform}".....c
1f30: 70 20 22 24 7b 66 69 6c 65 7d 22 20 22 24 7b 6f  p "${file}" "${o
1f40: 75 74 64 69 72 7d 2f 24 7b 70 6c 61 74 66 6f 72  utdir}/${platfor
1f50: 6d 7d 22 0a 09 09 09 63 6f 70 69 65 64 3d 27 31  m}"....copied='1
1f60: 27 0a 09 09 66 69 0a 09 64 6f 6e 65 0a 0a 09 69  '...fi..done...i
1f70: 66 20 5b 20 22 24 7b 63 6f 70 69 65 64 7d 22 20  f [ "${copied}" 
1f80: 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a 09 09  = '0' ]; then...
1f90: 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 55 6e 61  echo "error: Una
1fa0: 62 6c 65 20 74 6f 20 63 6f 70 79 20 62 75 69 6c  ble to copy buil
1fb0: 74 20 6c 69 62 63 61 63 6b 65 79 20 74 6f 20 6c  t libcackey to l
1fc0: 6f 63 61 6c 20 64 69 72 65 63 74 6f 72 79 22 20  ocal directory" 
1fd0: 3e 26 32 0a 0a 09 09 72 65 74 75 72 6e 20 31 0a  >&2....return 1.
1fe0: 09 66 69 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d  .fi...return 0.}
1ff0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65 61 6e  ..function clean
2000: 75 70 28 29 20 7b 0a 09 69 66 20 5b 20 2d 6e 20  up() {..if [ -n 
2010: 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  "${cackeyChromeE
2020: 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 22 20  xtPCSCLiteDir}" 
2030: 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20 2d 72 66  ]; then...rm -rf
2040: 20 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65   "${cackeyChrome
2050: 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 22  ExtPCSCLiteDir}"
2060: 0a 09 09 75 6e 73 65 74 20 50 43 53 43 5f 43 46  ...unset PCSC_CF
2070: 4c 41 47 53 20 50 43 53 43 5f 4c 49 42 53 0a 09  LAGS PCSC_LIBS..
2080: 66 69 0a 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b  fi...if [ -n "${
2090: 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 4c  cackeyChromeExtL
20a0: 69 62 55 53 42 44 69 72 7d 22 20 5d 3b 20 74 68  ibUSBDir}" ]; th
20b0: 65 6e 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 63  en...rm -rf "${c
20c0: 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 4c 69  ackeyChromeExtLi
20d0: 62 55 53 42 44 69 72 7d 22 0a 09 09 75 6e 73 65  bUSBDir}"...unse
20e0: 74 20 4c 49 42 55 53 42 5f 4c 49 42 53 20 4c 49  t LIBUSB_LIBS LI
20f0: 42 55 53 42 5f 43 46 4c 41 47 53 0a 09 66 69 0a  BUSB_CFLAGS..fi.
2100: 7d 0a 0a 6f 75 74 64 69 72 3d 22 77 6f 72 6b 64  }..outdir="workd
2110: 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41  ir-${RANDOM}${RA
2120: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
2130: 52 41 4e 44 4f 4d 7d 2e 6f 75 74 22 0a 72 6d 20  RANDOM}.out".rm 
2140: 2d 72 66 20 22 24 7b 6f 75 74 64 69 72 7d 22 0a  -rf "${outdir}".
2150: 6d 6b 64 69 72 20 22 24 7b 6f 75 74 64 69 72 7d  mkdir "${outdir}
2160: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 62 75 69  " || exit 1..bui
2170: 6c 64 50 43 53 43 4c 69 74 65 20 7c 7c 20 65 78  ldPCSCLite || ex
2180: 69 74 20 31 0a 0a 62 75 69 6c 64 43 41 43 4b 65  it 1..buildCACKe
2190: 79 20 62 75 69 6c 64 20 7c 7c 20 65 78 69 74 20  y build || exit 
21a0: 31 0a 0a 62 75 69 6c 64 4f 75 74 70 75 74 54 79  1..buildOutputTy
21b0: 70 65 3d 22 24 28 65 63 68 6f 20 27 69 6e 74 20  pe="$(echo 'int 
21c0: 6d 61 69 6e 28 69 6e 74 20 61 72 67 63 2c 20 63  main(int argc, c
21d0: 68 61 72 20 2a 2a 61 72 67 76 29 20 7b 20 72 65  har **argv) { re
21e0: 74 75 72 6e 28 30 29 3b 20 7d 27 20 7c 20 22 24  turn(0); }' | "$
21f0: 7b 43 43 3a 2d 63 63 7d 22 20 2d 78 20 63 20 2d  {CC:-cc}" -x c -
2200: 20 2d 6f 20 2f 64 65 76 2f 73 74 64 6f 75 74 20   -o /dev/stdout 
2210: 7c 20 66 69 6c 65 20 2d 29 22 20 7c 7c 20 65 78  | file -)" || ex
2220: 69 74 20 31 0a 63 61 73 65 20 22 24 7b 62 75 69  it 1.case "${bui
2230: 6c 64 4f 75 74 70 75 74 54 79 70 65 7d 22 20 69  ldOutputType}" i
2240: 6e 0a 09 2a 78 38 36 2d 36 34 2a 29 0a 09 09 6e  n..*x86-64*)...n
2250: 61 63 6c 54 6f 70 44 69 72 3d 27 6c 69 6e 75 78  aclTopDir='linux
2260: 5f 78 38 36 5f 67 6c 69 62 63 27 0a 09 09 6e 61  _x86_glibc'...na
2270: 63 6c 50 6c 61 74 66 6f 72 6d 3d 27 78 38 36 5f  clPlatform='x86_
2280: 36 34 2d 6e 61 63 6c 27 0a 09 09 3b 3b 0a 09 2a  64-nacl'...;;..*
2290: 29 0a 09 09 65 63 68 6f 20 22 65 72 72 6f 72 3a  )...echo "error:
22a0: 20 55 6e 72 65 63 6f 67 6e 69 7a 65 64 20 70 6c   Unrecognized pl
22b0: 61 74 66 6f 72 6d 20 6f 75 74 70 75 74 3a 20 5c  atform output: \
22c0: 22 24 7b 62 75 69 6c 64 4f 75 74 70 75 74 54 79  "${buildOutputTy
22d0: 70 65 7d 5c 22 22 20 3e 26 32 0a 0a 09 09 65 78  pe}\"" >&2....ex
22e0: 69 74 20 31 0a 09 09 3b 3b 0a 65 73 61 63 0a 50  it 1...;;.esac.P
22f0: 41 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b 4e  ATH="${PATH}:${N
2300: 41 43 4c 5f 53 44 4b 5f 52 4f 4f 54 7d 2f 74 6f  ACL_SDK_ROOT}/to
2310: 6f 6c 63 68 61 69 6e 2f 24 7b 6e 61 63 6c 54 6f  olchain/${naclTo
2320: 70 44 69 72 7d 2f 62 69 6e 22 20 62 75 69 6c 64  pDir}/bin" build
2330: 43 41 43 4b 65 79 20 22 24 7b 6e 61 63 6c 50 6c  CACKey "${naclPl
2340: 61 74 66 6f 72 6d 7d 22 20 2d 2d 68 6f 73 74 3d  atform}" --host=
2350: 22 24 7b 6e 61 63 6c 50 6c 61 74 66 6f 72 6d 7d  "${naclPlatform}
2360: 22 20 43 43 3d 24 7b 6e 61 63 6c 50 6c 61 74 66  " CC=${naclPlatf
2370: 6f 72 6d 7d 2d 67 63 63 20 4c 44 3d 24 7b 6e 61  orm}-gcc LD=${na
2380: 63 6c 50 6c 61 74 66 6f 72 6d 7d 2d 6c 64 20 4f  clPlatform}-ld O
2390: 42 4a 43 4f 50 59 3d 24 7b 6e 61 63 6c 50 6c 61  BJCOPY=${naclPla
23a0: 74 66 6f 72 6d 7d 2d 6f 62 6a 63 6f 70 79 20 53  tform}-objcopy S
23b0: 54 52 49 50 3d 24 7b 6e 61 63 6c 50 6c 61 74 66  TRIP=${naclPlatf
23c0: 6f 72 6d 7d 2d 73 74 72 69 70 20 7c 7c 20 65 78  orm}-strip || ex
23d0: 69 74 20 31 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65  it 1..cleanup..e
23e0: 78 69 74 20 30 0a                                xit 0.